SystemOrganization addCategory: #'Cache-Visual-Analysis'!

Object subclass: #CachingVarFigures
	instanceVariableNames: 'cacheCollection imageInfo container cacheSet filePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Visual-Analysis'!

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 10/29/2015 11:55'!
averageAndDeviation: aCollection

	| average deviation |
	average := aCollection average asFloat.
	deviation := ((aCollection 
		detectSum: [ :each | (each - average) * (each - average) ]) 
			/ aCollection size) sqrt.
			
	^ average -> deviation
	! !

!CachingVarFigures methodsFor: 'figs' stamp: 'NickPapoulias 11/10/2015 12:36'!
cachingImplPropertiesGraph

	| b |
	b := RTStackBarPlot new.
	b interaction popupText.
	b colorPalette colors: (Array with: Color green with: Color blue).
	"b add: (self statsWithValues)	title: 'Static Value ?'."
	b add: (self propertyStats: #aggregate)	 title: 'Is aggregate ?'.
	b add: (self propertyStats: #usesNil) title: 'Uses nil ?'.
	b add: (self propertyStats: #proper) title: 'Is proper ?'.
	b add: (self propertyStats: #exposable) title: 'Is exposed ?'.
	"b add: (self propertyStatsWithValues: #monomorphic) title: 'Is monomorphic ?'."
	"b add: { 	} title: 'Is weak ?'.
	b add: { 	} title: 'Is proper ?'."
	b addLegend: #('yes' 'no').
	b barWidth: 700 height: 70.

	b addLabelToBars: [ :assoc | ((assoc key  / b totalSum * 100) asFloat printShowingDecimalPlaces: 2), '%' ] if: [:assoc | assoc key > 5 ] color: Color white.

	b build.
	b view openInWindowSized: 1000 @ 450.
	self fixAndExport: b.
	^ b view! !

!CachingVarFigures methodsFor: 'figs' stamp: 'NickPapoulias 11/8/2015 17:48'!
cachingProtocolsGraph

	| b stats protocolToOccurencesDict|
	protocolToOccurencesDict := Dictionary new.
	stats := cacheSet asOrderedCollection flatCollect: [ :cvar | cvar protocols ].
	stats do: [ :protocol | 
				protocolToOccurencesDict at: protocol put: (protocolToOccurencesDict at: protocol ifAbsentPut: [ 0 ]) + 1.
	].
	protocolToOccurencesDict := protocolToOccurencesDict select: [ :assoc | assoc value >= 40 ].
	b := RTDoubleBarBuilder new.
	"b extent: 500 @ 200."

	b points: (protocolToOccurencesDict keys 
					sort: [:key1 :key2 | (protocolToOccurencesDict at: key1) <= (protocolToOccurencesDict at: key2)]).  .
	b bottomValue: [:x | protocolToOccurencesDict at: x] titled: 'occurences'.
	"b topValue: #numberOfVariables".
	"b axisX noTick; noLabel."
	b build.
	b view open.
	self fixAndExport: b.
	"RTPDFExporter new exportCanvas: b view canvas onFileName: filePath ,'cachingVarsKinds.pdf'."
	^ b view! !

!CachingVarFigures methodsFor: 'figs' stamp: 'NickPapoulias 11/8/2015 17:32'!
cachingSelectorsGraph

	| b stats selectorToOccurencesDict|
	selectorToOccurencesDict := Dictionary new.
	stats := cacheSet asOrderedCollection flatCollect: [ :cvar | cvar selectors ].
	stats do: [ :selector | 
				selectorToOccurencesDict at: selector put: (selectorToOccurencesDict at: selector ifAbsentPut: [ 0 ]) + 1.
	].
	selectorToOccurencesDict := selectorToOccurencesDict select: [ :assoc | assoc value >= 10 ].
	b := RTDoubleBarBuilder new.
	"b extent: 500 @ 200."

	b points: (selectorToOccurencesDict keys 
					sort: [:key1 :key2 | (selectorToOccurencesDict at: key1) <= (selectorToOccurencesDict at: key2)]).  .
	b bottomValue: [:x | selectorToOccurencesDict at: x] titled: 'occurences'.
	"b topValue: #numberOfVariables".
	"b axisX noTick; noLabel."
	b build.
	b view open.
	self fixAndExport: b.
	"RTPDFExporter new exportCanvas: b view canvas onFileName: filePath ,'cachingVarsKinds.pdf'."
	^ b view! !

!CachingVarFigures methodsFor: 'figs' stamp: 'NickPapoulias 11/8/2015 17:34'!
cachingValuesGraph


	| b ds stats classToTracesDict|
	classToTracesDict := Dictionary new.
	stats := cacheSet asOrderedCollection collect: [ :cvar | cvar values ].
	stats do: [ :classSet | 
		classSet do: [ :class | 
				(class isKindOf: Symbol)
					ifTrue: [classToTracesDict at: class put: (classToTracesDict at: class ifAbsentPut: [ 0 ]) + 1]
					ifFalse: "literal" [classToTracesDict at: class class name asSymbol put: (classToTracesDict at: class class name asSymbol ifAbsentPut: [ 0 ]) + 1]
		]	
	].
	classToTracesDict inspect.
	stats inspect.
	b := RTGrapher new.
	b extent: 500 @ 200.

	ds := RTData new.
	ds interaction highlight.
	ds points: classToTracesDict keys.
	ds barShape width: 10.
	ds y: [:x | classToTracesDict at: x].
	ds barShape 
		rectangle color: Color blue; 
		width: 10.
	ds barChartWithBarTitle: #name rotation: -45 color: Color black.
	b add: ds.

	b axisY.
	b axisX noTick; noLabel.
	b axisY noDecimal; title: 'Number of Vars'.
	b build.
	b view open.
	self fixAndExport: b.
	^ b view! !

!CachingVarFigures methodsFor: 'figs' stamp: 'NickPapoulias 11/8/2015 17:10'!
cachingVarsDensityGraph

|b2   ds detectorStats |

detectorStats := self packageAnalysisDensityOfCaches.


b2 := RTGrapher new.
"b2 view: c view.
b2 extent: 200 @ 150."

ds := RTData new.
"ds interaction popup."
ds dotShape circle color: Color red.
ds points: detectorStats associations.
"ds x: [ :point | point key ]."
ds y: [ :point | point value ].
ds connectColor: Color blue.
"ds barShape rectangle color: Color lightBlue."
b2 add: ds.
"b2 axisX; axisYWithNumberOfTicks: 4.
"
b2 axisX noDecimal; title: 'PkgGroup-ID'.
b2 axisY title: 'Caches per Class'.
b2 build.
self fixAndExport: b2.
b2 view open.
^ b2 view! !

!CachingVarFigures methodsFor: 'figs' stamp: 'NickPapoulias 11/8/2015 14:52'!
cachingVarsKinds

	| b  stats  |
	b := RTDoubleBarBuilder new.
	stats := Dictionary new.
	stats 
		at: 'Instance Variables' 
		put: (cacheSet select: [:cvar | cvar class = InstanceSideCachingVariable]) size. 
	stats 
		at: 'Class-Side Variables' 
		put: (cacheSet select: [:cvar | cvar class = ClassSideCachingVariable]) size.
	stats 
		at: 'Shared Variables' 
		put: (cacheSet select: [:cvar | cvar class = SharedCachingVariable]) size.			
	stats 
		at: 'Temporary Variables' 
		put: (cacheSet select: [:cvar | cvar class = TempCachingVariable]) size.
	b points: stats keys.
	b bottomValue: [:x | stats at: x] titled: 'occurences'.
	"b topValue: #numberOfVariables".
	"b axisX noTick; noLabel."
	b build.
	b view open.
	self fixAndExport: b.
	"RTPDFExporter new exportCanvas: b view canvas onFileName: filePath ,'cachingVarsKinds.pdf'."
	^ b view! !

!CachingVarFigures methodsFor: 'figs' stamp: 'NickPapoulias 11/8/2015 14:52'!
cachingVarsPerPackageGroupPie

| b  lb normalizer packagesToCachesWithMoreThanTen packagesToCachesWithLessThanTen lessThanTenAcc stats lessThanTenSize detectorStats allCaches |

stats := Dictionary new.
detectorStats := self packageAnalysisNumberOfCaches.
allCaches := cacheSet size.
packagesToCachesWithMoreThanTen := (detectorStats associations sort: [ :a :c | a value > c value ]) select: [ :assoc | assoc value >= 10 ]. 
packagesToCachesWithLessThanTen := (detectorStats associations sort: [ :a :c | a value > c value ]) select: [ :assoc | assoc value  < 10 ].
lessThanTenAcc := 0.
lessThanTenSize := packagesToCachesWithLessThanTen size. 
packagesToCachesWithLessThanTen do: [ :assoc | lessThanTenAcc := lessThanTenAcc + assoc value ].
packagesToCachesWithMoreThanTen do: [ :assoc | 
	stats at: (assoc key name , ' (' , assoc value asString ,')') put: assoc value.	
].

stats at: 'PkgGroups with < 10 Vars' , ' (' , lessThanTenAcc asString ,')'  put: lessThanTenAcc.
 
b := RTPieBuilder new.
b interaction popup.
b objects: stats keys.
b slice: [:x | stats at: x].
b normalizer distinctColor.	
b labelled.
"b emphasize: Set by: 20.
b emphasize: Dictionary by: 20."

"Legend"
lb := RTLegendBuilder new.
lb view: b view.
lb addText: allCaches asString , ' caches in ' , detectorStats size asString , ' package Groups out of ' , imageInfo packageGroupsToNumberOfClasses size asString , ' in the system.' .
normalizer := RTMultiLinearColorForIdentity new objects: stats keys.
stats keys do: [ :package |
	lb addColor: (normalizer rtValue: package) text: package.
].
lb build.
b build.
b view open.
self fixAndExport: b.
"RTPDFExporter new exportCanvas: b view canvas onFileName: filePath , 'cachingVarsPerPackageGroupPie.pdf'.
"^ b view! !

!CachingVarFigures methodsFor: 'figs' stamp: 'NickPapoulias 11/8/2015 14:52'!
cachingVarsToNumberOfPackageGroupsGraph

	|b2   ds numberOfCachesToNumberOfPackages detectorStats |

	detectorStats := self packageAnalysisNumberOfCaches.
	numberOfCachesToNumberOfPackages := Dictionary new.

	detectorStats values asSet do: [:numberOfCaches |
		numberOfCachesToNumberOfPackages	at: numberOfCaches put: (detectorStats select: [:value | value = numberOfCaches]) size.
	].


	b2 := RTGrapher new.
	"b2 view: c view.
	b2 extent: 200 @ 150."

	ds := RTData new.
	"ds interaction popup."
	ds dotShape circle color: Color red.
	ds points: numberOfCachesToNumberOfPackages associations sort.
	ds x: [ :point | point key ].
	ds y: [ :point | point value ].
	ds connectColor: Color blue.
	"ds barShape rectangle color: Color lightBlue."
	b2 add: ds.
	"b2 axisX; axisYWithNumberOfTicks: 4.
	"
	b2 axisX noDecimal; title: 'Number of Caches'.
	b2 axisY noDecimal; title: 'Number of Packages'.
	b2 build.
	b2 view open.
	self fixAndExport: b2.
	^ b2 view! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 10/28/2015 18:58'!
exportFilePath: aFilepath

	filePath := aFilepath , '/'
	! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 11/8/2015 17:05'!
exportStat: anObject

	(FileStream fileNamed: 'stats.txt')
		nextPutAll: thisContext sender method selector asString;
		nextPut: Character cr;
		nextPutAll: anObject asString;
		nextPut: Character cr;
		close.
	^ anObject! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 11/8/2015 14:51'!
fixAndExport: abuilder

	self fixColoringFor: abuilder.
	PNGReadWriter 
		putForm: abuilder view canvas morph imageForm 
		onFileNamed: thisContext method selector asString.
! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 11/8/2015 13:35'!
fixColoringFor: builder

	(builder view canvas shapes 
		select: [:shape | shape isKindOf: TRLabelShape])
		do: [ :label | label color: Color black ]! !

!CachingVarFigures methodsFor: 'generate-all-figs' stamp: 'NickPapoulias 11/10/2015 13:45'!
generateAllFigs

	|figsSelectors|

	figsSelectors := (self class methods 
		select: [ :method | method protocol = 'figs' ])
		collect: [ :method | method selector ].
	figsSelectors do: [ :selector | self perform: selector ]! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 11/10/2015 18:41'!
importFromFuel: aFileName for: aCacheCollectionSubclass

	container := aCacheCollectionSubclass 
			importFromFuel: "(Smalltalk imageDirectory parent pathString , "aFileName.
	cacheCollection := container collection.
	cacheSet := container collectionAsSet.
	imageInfo := container imageInfo. 
	! !

!CachingVarFigures methodsFor: 'figs' stamp: 'NickPapoulias 11/10/2015 12:55'!
lazyDictPattern

	| b |
	b := RTStackBarPlot new.
	b interaction popupText.
	b colorPalette colors: (Array with: Color green with: Color blue).
	"b add: (self statsWithValues)	title: 'Static Value ?'."
	b add: (self patternStats: #LazyDictionaryFillingPattern forSelector: #existAccessPatternOfVar:inClass:)	 title: 'Access Pattern ?'.
	b add: (self patternStats: #LazyDictionaryFillingPattern forSelector: #existFillingPatternOfVar:inClass:) title: 'Filling Pattern ?'.
	b add: (self patternStats: #LazyDictionaryFillingPattern forSelector: #existInvalidationPatternOfVar:inClass:) title: 'Invalidation Pattern ?'.
	"b add: (self propertyStatsWithValues: #monomorphic) title: 'Is monomorphic ?'."
	"b add: { 	} title: 'Is weak ?'.
	b add: { 	} title: 'Is proper ?'."
	b addLegend: #('yes' 'no').
	b barWidth: 700 height: 70.

	b addLabelToBars: [ :assoc | ((assoc key  / b totalSum * 100) asFloat printShowingDecimalPlaces: 2), '%' ] if: [:assoc | assoc key > 5 ] color: Color white.

	b build.
	b view openInWindowSized: 1000 @ 450.
	self fixAndExport: b.
	^ b view! !

!CachingVarFigures methodsFor: 'figs' stamp: 'NickPapoulias 11/10/2015 13:05'!
lazyInitPattern

	| b |
	b := RTStackBarPlot new.
	b interaction popupText.
	b colorPalette colors: (Array with: Color green with: Color blue).
	"b add: (self statsWithValues)	title: 'Static Value ?'."
	b add: (self patternStats: #LazyInitializePattern forSelector: #existAccessPatternOfVar:inClass:)	 title: 'Access Pattern ?'.
	b add: (self patternStats: #LazyInitializePattern forSelector: #existFillingPatternOfVar:inClass:) title: 'Filling Pattern ?'.
	b add: (self patternStats: #LazyInitializePattern forSelector: #existInvalidationPatternOfVar:inClass:) title: 'Invalidation Pattern ?'.
	"b add: (self propertyStatsWithValues: #monomorphic) title: 'Is monomorphic ?'."
	"b add: { 	} title: 'Is weak ?'.
	b add: { 	} title: 'Is proper ?'."
	b addLegend: #('yes' 'no').
	b barWidth: 700 height: 70.

	b addLabelToBars: [ :assoc | ((assoc key  / b totalSum * 100) asFloat printShowingDecimalPlaces: 2), '%' ] if: [:assoc | assoc key > 5 ] color: Color white.

	b build.
	b view openInWindowSized: 1000 @ 450.
	self fixAndExport: b.
	^ b view! !

!CachingVarFigures methodsFor: 'figs' stamp: 'NickPapoulias 11/10/2015 13:08'!
methodMemoizationPattern

	| b |
	b := RTStackBarPlot new.
	b interaction popupText.
	b colorPalette colors: (Array with: Color green with: Color blue).
	"b add: (self statsWithValues)	title: 'Static Value ?'."
	b add: (self patternStats: #MethodMemoizationPattern forSelector: #existAccessPatternOfVar:inClass:)	 title: 'Access Pattern ?'.
	b add: (self patternStats: #MethodMemoizationPattern forSelector: #existFillingPatternOfVar:inClass:) title: 'Filling Pattern ?'.
	b add: (self patternStats: #MethodMemoizationPattern forSelector: #existInvalidationPatternOfVar:inClass:) title: 'Invalidation Pattern ?'.
	"b add: (self propertyStatsWithValues: #monomorphic) title: 'Is monomorphic ?'."
	"b add: { 	} title: 'Is weak ?'.
	b add: { 	} title: 'Is proper ?'."
	b addLegend: #('yes' 'no').
	b barWidth: 700 height: 70.

	b addLabelToBars: [ :assoc | ((assoc key  / b totalSum * 100) asFloat printShowingDecimalPlaces: 2), '%' ] if: [:assoc | assoc key > 5 ] color: Color white.

	b build.
	b view openInWindowSized: 1000 @ 450.
	self fixAndExport: b.
	^ b view! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 10/29/2015 11:54'!
minMax: aCollection
			
	^ aCollection min -> aCollection max
	! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 10/29/2015 11:05'!
packageAnalysisDensityOfCaches

	"easy and nice to have, plus it will help with analysis of third-party projects"

	| packageToNumberOfCachesDict packageToDensityOfCachesDict|
	packageToNumberOfCachesDict := self packageAnalysisNumberOfCaches.
	packageToDensityOfCachesDict := Dictionary new.
	packageToNumberOfCachesDict keysAndValuesDo: [ :key :value | 
		packageToDensityOfCachesDict at: key put: value asFloat / (imageInfo packageGroupsToNumberOfClasses at: key)
	].
	^ packageToDensityOfCachesDict
	! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 11/8/2015 15:03'!
packageAnalysisDensityOfCachesSystem

	"easy and nice to have, plus it will help with analysis of third-party projects"

	| packageToNumberOfCachesDict packageToDensityOfCachesDict|
	packageToNumberOfCachesDict := self packageAnalysisNumberOfCachesSystem.
	packageToDensityOfCachesDict := Dictionary new.
	packageToNumberOfCachesDict keysAndValuesDo: [ :key :value | 
		packageToDensityOfCachesDict at: key put: value asFloat / (imageInfo packageGroupsToNumberOfClasses at: key)
	].
	^ packageToDensityOfCachesDict
	! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 10/28/2015 18:13'!
packageAnalysisNumberOfCaches

	| packageGroupToNumberOfCaches |
	packageGroupToNumberOfCaches := Dictionary new.
	
	cacheSet do: [ :cvar | 
		packageGroupToNumberOfCaches 
			at: cvar packageGroup
			put: (packageGroupToNumberOfCaches at: cvar packageGroup ifAbsentPut: 0) + 1	
	].

	^ packageGroupToNumberOfCaches
	! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 11/8/2015 15:03'!
packageAnalysisNumberOfCachesSystem

	| packageGroupToNumberOfCaches |
	packageGroupToNumberOfCaches := Dictionary new.
	
	cacheSet do: [ :cvar | 
		packageGroupToNumberOfCaches 
			at: cvar packageGroup
			put: (packageGroupToNumberOfCaches at: cvar packageGroup ifAbsentPut: 0) + 1	
	].

	imageInfo packageGroupsToNumberOfClasses keys do: [ :pGroup | packageGroupToNumberOfCaches at: pGroup ifAbsentPut: 0 ].

	^ packageGroupToNumberOfCaches
	! !

!CachingVarFigures methodsFor: 'stats' stamp: 'NickPapoulias 11/8/2015 15:27'!
packageDensityMinMaxAvgDeviationOfDetectedSet

	|packageToDensityOfCaches|

	packageToDensityOfCaches := self packageAnalysisDensityOfCaches. 

	^ self exportStat: 
		(self minMax: packageToDensityOfCaches values) -> 
		(self averageAndDeviation: packageToDensityOfCaches values) 
	! !

!CachingVarFigures methodsFor: 'stats' stamp: 'NickPapoulias 11/8/2015 15:27'!
packageDensityMinMaxAvgDeviationOfSystem

	|packageToDensityOfCaches|

	packageToDensityOfCaches := self packageAnalysisDensityOfCachesSystem. 

	^ self exportStat: 
		(self minMax: packageToDensityOfCaches values) -> 
		(self averageAndDeviation: packageToDensityOfCaches values) 
	! !

!CachingVarFigures methodsFor: 'stats' stamp: 'NickPapoulias 11/8/2015 15:27'!
packageDistributionMinMaxAvgDeviationOfDetectedSet

	|packageToNumberOfCaches|

	packageToNumberOfCaches := self packageAnalysisNumberOfCaches. 

	^ self exportStat:  
		(self minMax: packageToNumberOfCaches values) -> 
		(self averageAndDeviation: packageToNumberOfCaches values) 
	! !

!CachingVarFigures methodsFor: 'stats' stamp: 'NickPapoulias 11/8/2015 15:10'!
packageDistributionMinMaxAvgDeviationOfSystem

	|packageToNumberOfCaches|

	packageToNumberOfCaches := self packageAnalysisNumberOfCachesSystem. 

	^	self exportStat:  
			(self minMax: packageToNumberOfCaches values) -> 
			(self averageAndDeviation: packageToNumberOfCaches values) 
	! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 11/10/2015 13:03'!
patternStats: aPatternClassAsSymbol forSelector: aSelector

	| yes no |
	yes := (cacheSet asOrderedCollection select: [:cvar | ((cvar patterns at: aPatternClassAsSymbol) at: aSelector) = true  ]) size.
	no := cacheSet size - yes.
	^ { yes . no }! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 11/8/2015 20:35'!
propertyStats: property

	| yes no |
	yes := (cacheSet asOrderedCollection select: [:cvar | cvar properties at: property  ]) size.
	no := cacheSet size - yes.
	^ { yes . no }! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 11/8/2015 21:20'!
propertyStatsWithValues: property

	| yes no |
	yes := (cacheSet asOrderedCollection select: [:cvar | cvar values isEmpty not and: [  (cvar properties at: property) = true ]  ]) size.
	no := (cacheSet asOrderedCollection select: [:cvar | cvar values isEmpty not and: [  (cvar properties at: property) = false ]  ]) size.
	^ { yes . no }! !

!CachingVarFigures methodsFor: 'helpers' stamp: 'NickPapoulias 11/8/2015 21:18'!
statsWithValues

	| yes no |
	yes := (cacheSet asOrderedCollection select: [:cvar | cvar values isEmpty not ]) size.
	no := cacheSet size - yes.
	^ { yes . no }! !
